# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.239
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class GroupReconciliationAggregateAttributeValues(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'left_aggregate_attributes': 'list[ComparisonAttributeValuePair]',
        'right_aggregate_attributes': 'list[ComparisonAttributeValuePair]'
    }

    attribute_map = {
        'left_aggregate_attributes': 'leftAggregateAttributes',
        'right_aggregate_attributes': 'rightAggregateAttributes'
    }

    required_map = {
        'left_aggregate_attributes': 'required',
        'right_aggregate_attributes': 'required'
    }

    def __init__(self, left_aggregate_attributes=None, right_aggregate_attributes=None, local_vars_configuration=None):  # noqa: E501
        """GroupReconciliationAggregateAttributeValues - a model defined in OpenAPI"
        
        :param left_aggregate_attributes:  Aggregate attribute names and values for the left hand entity being reconciled. (required)
        :type left_aggregate_attributes: list[lusid.ComparisonAttributeValuePair]
        :param right_aggregate_attributes:  Aggregate attribute names and values for the right hand entity being reconciled. (required)
        :type right_aggregate_attributes: list[lusid.ComparisonAttributeValuePair]

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._left_aggregate_attributes = None
        self._right_aggregate_attributes = None
        self.discriminator = None

        self.left_aggregate_attributes = left_aggregate_attributes
        self.right_aggregate_attributes = right_aggregate_attributes

    @property
    def left_aggregate_attributes(self):
        """Gets the left_aggregate_attributes of this GroupReconciliationAggregateAttributeValues.  # noqa: E501

        Aggregate attribute names and values for the left hand entity being reconciled.  # noqa: E501

        :return: The left_aggregate_attributes of this GroupReconciliationAggregateAttributeValues.  # noqa: E501
        :rtype: list[lusid.ComparisonAttributeValuePair]
        """
        return self._left_aggregate_attributes

    @left_aggregate_attributes.setter
    def left_aggregate_attributes(self, left_aggregate_attributes):
        """Sets the left_aggregate_attributes of this GroupReconciliationAggregateAttributeValues.

        Aggregate attribute names and values for the left hand entity being reconciled.  # noqa: E501

        :param left_aggregate_attributes: The left_aggregate_attributes of this GroupReconciliationAggregateAttributeValues.  # noqa: E501
        :type left_aggregate_attributes: list[lusid.ComparisonAttributeValuePair]
        """
        if self.local_vars_configuration.client_side_validation and left_aggregate_attributes is None:  # noqa: E501
            raise ValueError("Invalid value for `left_aggregate_attributes`, must not be `None`")  # noqa: E501

        self._left_aggregate_attributes = left_aggregate_attributes

    @property
    def right_aggregate_attributes(self):
        """Gets the right_aggregate_attributes of this GroupReconciliationAggregateAttributeValues.  # noqa: E501

        Aggregate attribute names and values for the right hand entity being reconciled.  # noqa: E501

        :return: The right_aggregate_attributes of this GroupReconciliationAggregateAttributeValues.  # noqa: E501
        :rtype: list[lusid.ComparisonAttributeValuePair]
        """
        return self._right_aggregate_attributes

    @right_aggregate_attributes.setter
    def right_aggregate_attributes(self, right_aggregate_attributes):
        """Sets the right_aggregate_attributes of this GroupReconciliationAggregateAttributeValues.

        Aggregate attribute names and values for the right hand entity being reconciled.  # noqa: E501

        :param right_aggregate_attributes: The right_aggregate_attributes of this GroupReconciliationAggregateAttributeValues.  # noqa: E501
        :type right_aggregate_attributes: list[lusid.ComparisonAttributeValuePair]
        """
        if self.local_vars_configuration.client_side_validation and right_aggregate_attributes is None:  # noqa: E501
            raise ValueError("Invalid value for `right_aggregate_attributes`, must not be `None`")  # noqa: E501

        self._right_aggregate_attributes = right_aggregate_attributes

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GroupReconciliationAggregateAttributeValues):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GroupReconciliationAggregateAttributeValues):
            return True

        return self.to_dict() != other.to_dict()
