# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.239
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class GroupReconciliationInstanceId(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'run_id_type': 'str',
        'run_id_value': 'str'
    }

    attribute_map = {
        'run_id_type': 'runIdType',
        'run_id_value': 'runIdValue'
    }

    required_map = {
        'run_id_type': 'required',
        'run_id_value': 'required'
    }

    def __init__(self, run_id_type=None, run_id_value=None, local_vars_configuration=None):  # noqa: E501
        """GroupReconciliationInstanceId - a model defined in OpenAPI"
        
        :param run_id_type:  Type of the reconciliation run, manual or automatic (via the workflow). \"Manual\" | \"WorkflowServiceTaskId\" (required)
        :type run_id_type: str
        :param run_id_value:  Reconciliation run identifier: a manually-provided key or taskId. (required)
        :type run_id_value: str

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._run_id_type = None
        self._run_id_value = None
        self.discriminator = None

        self.run_id_type = run_id_type
        self.run_id_value = run_id_value

    @property
    def run_id_type(self):
        """Gets the run_id_type of this GroupReconciliationInstanceId.  # noqa: E501

        Type of the reconciliation run, manual or automatic (via the workflow). \"Manual\" | \"WorkflowServiceTaskId\"  # noqa: E501

        :return: The run_id_type of this GroupReconciliationInstanceId.  # noqa: E501
        :rtype: str
        """
        return self._run_id_type

    @run_id_type.setter
    def run_id_type(self, run_id_type):
        """Sets the run_id_type of this GroupReconciliationInstanceId.

        Type of the reconciliation run, manual or automatic (via the workflow). \"Manual\" | \"WorkflowServiceTaskId\"  # noqa: E501

        :param run_id_type: The run_id_type of this GroupReconciliationInstanceId.  # noqa: E501
        :type run_id_type: str
        """
        if self.local_vars_configuration.client_side_validation and run_id_type is None:  # noqa: E501
            raise ValueError("Invalid value for `run_id_type`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                run_id_type is not None and len(run_id_type) < 1):
            raise ValueError("Invalid value for `run_id_type`, length must be greater than or equal to `1`")  # noqa: E501

        self._run_id_type = run_id_type

    @property
    def run_id_value(self):
        """Gets the run_id_value of this GroupReconciliationInstanceId.  # noqa: E501

        Reconciliation run identifier: a manually-provided key or taskId.  # noqa: E501

        :return: The run_id_value of this GroupReconciliationInstanceId.  # noqa: E501
        :rtype: str
        """
        return self._run_id_value

    @run_id_value.setter
    def run_id_value(self, run_id_value):
        """Sets the run_id_value of this GroupReconciliationInstanceId.

        Reconciliation run identifier: a manually-provided key or taskId.  # noqa: E501

        :param run_id_value: The run_id_value of this GroupReconciliationInstanceId.  # noqa: E501
        :type run_id_value: str
        """
        if self.local_vars_configuration.client_side_validation and run_id_value is None:  # noqa: E501
            raise ValueError("Invalid value for `run_id_value`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                run_id_value is not None and len(run_id_value) < 1):
            raise ValueError("Invalid value for `run_id_value`, length must be greater than or equal to `1`")  # noqa: E501

        self._run_id_value = run_id_value

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GroupReconciliationInstanceId):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GroupReconciliationInstanceId):
            return True

        return self.to_dict() != other.to_dict()
